<?php
//----------------------------------------------------------------------------------
// METABOX - REFERENCE MAKER
//----------------------------------------------------------------------------------
function netblog_mtbox_refmaker()
{
	if( function_exists('add_meta_box') ) {
		add_meta_box('netblog_refmaker', 'Reference Maker', 'netblog_refmaker', 'post', 'side','');
		add_meta_box('netblog_refmaker', 'Reference Maker', 'netblog_refmaker', 'page', 'side','');
	} else {
		//add_action('dbx_post_advanced', 'myplugin_old_custom_box' ); 
	}
	netblog_plugin_styles();		
}
add_action('admin_init', 'netblog_mtbox_refmaker');

function netblog_refmaker()
{
	?>
	<p>
	<!-- 
	<select onchange="mksubslct('nb-menu-main','menubody')" onkeyup="mksubslct('nb-menu-main','menubody')" id="nb-menu-main"><option >Create</option><option value="mk">Make</option><option value="ref">Reference</option></select>
	<span id="menubody" style="display: inline"></span><br /> -->
	Wizard: <select onchange="mkbodyS(this)" onkeyup="mkbodyS(this)" id="nb-menu">
		<optgroup label="Create">
			<option value="mk-note">Footnote</option>
			<option value="mk-cite">Citation</option>
			<option value="mk-caption">Caption</option>
		</optgroup>
		<optgroup label="Cross-reference">
			<option value="ref-caption">Caption</option>
		</optgroup>
		<optgroup label="Tables">
			<option value="lst-note">Footnotes</option>
			<option value="mk-biblio">Bibliography</option>
		</optgroup>
	</select>	
	</p>
	<hr style="border: 1px solid #DDD" />
	<div id="nb-mk-note" style="display:none">
		<p>
		<input type="checkbox" name="print" value="true" onclick="note_toogle('nb-mk-note-content','nb-mk-note-content-input')" id="nb-mk-note-print" /> 
			<label for="nb-mk-note-print">Print Footnotes</label>
		</p>	
		<p id="nb-mk-note-content">
		<label for="nb-mk-note-content-input"><b>Your Footnote</b></label>
		<textarea rows="3" style="width:100%" name="content" id="nb-mk-note-content-input"></textarea>
		</p>	
		<p>
		<label for="nb-mk-note-go"><b>Copy &amp; Paste</b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-note',this)" name="nbnote" id="nb-mk-note-go"></textarea>
		</p>		
	</div>
	
	<?php
	$formats = array( 'decimal'=>1, 
					  'lower-alpha' => 'a', 'lower-greek'=>'a', 'lower-roman'=>1,
					  'upper-alpha'=> 'A', 'upper-roman' =>1 );
	foreach( $formats as $k=>$v ) {
		$t = array();
		$i = 1;
		$t[0] = netblog_caption_increment($i,$k,0);
		$t[1] = netblog_caption_increment($i++,$k);
		$t[2] = netblog_caption_increment($i++,$k);
		$t[3] = netblog_caption_increment($i++,$k);
		$formats[$k] = implode(', ',$t) . ', ...';
	}	
	
	?>
	<div id="nb-mk-caption" style="display:none">
		<p>
		<label for="nb-mk-caption-type"><b>Type</b> <small>(required)</small></label><br />
		<input type="text" name="type" style="width:100%" onblur="clean(this);str2alphanum(this);input_strip(this,32);" id="nb-mk-caption-type" />
		</p>
		<p>
		<label for="nb-mk-caption-name"><b>Name</b> <small>(must be unique for this site; required)</small></label><br />
		<input type="text" name="name" style="width:100%" onblur="clean(this);str2alphanum(this);input_strip(this,125);" id="nb-mk-caption-name" />
		</p>
		<p>
		<label for="nb-mk-caption-title">Title <small>(optional)</small></label><br />
		<input type="text" name="title" style="width:100%" onblur="clean(this);str2alphanum(this);input_strip(this,125);" id="nb-mk-caption-title" />
		</p>		
		<p>
		<label for="nb-mk-caption-format">Format <small>(optional)</small></label><br /><select name="format" id="nb-mk-caption-format" style="width:100%">
		<?php foreach( $formats as $k=>$v) echo '<option value="'.$k.'">'.$v.'</option>';  ?>
		</select>
		</p>
		<p>
		<label>Display <small>(the first of each type per post counts)</small></label><br />
		<select style="width:100%" name="display"><option value="">Default</option><option value="inline">Inline</option><option value="right">Right</option><option value="left">Left</option></select>
		</p>
		<p>
		<label for="nb-mk-caption-print">Print <small>(optional; e.g. ($number), [$number])</small></label><br />
		<input type="text" name="print" style="width:100%" value="" onblur="clean(this)" id="nb-mk-caption-print" />
		</p>		
		<p>
		<label for="nb-mk-caption-go"><b>Copy &amp; Paste</b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-caption',this)" name="nbcaption" id="nb-mk-caption-go"></textarea>
		</p>		
	</div>	
	
	<?php
	// CITATION
	
	$cstyles = netblog_sc_cite_styles_custom();
	$cstylesPrint = $cstyles;
	if( $cstylesPrint == '' ) $cstylesPrint = 'none';
	
	// MK SELECT FILTER TYPE
	$selectFilterType = '';
	$t = netblog_sc_cite_filter_types_default();
	foreach($t as $k=>$v)
		$selectFilterType .= "<option value=\"$k\">$v</option>";
		

	// MK SELECT CUSTOM STYLE
	$optioncStyle = '';
	$t = explode(', ',$cstyles);
	foreach( $t as $v )
		$optioncStyle .= "<option value=\"$v\">$v</option>";
	
	// MK SELECT DEFAULT STYLES
	$optionDftStyle = '';
	$t = netblog_sc_cite_styles_default();
	foreach( $t as $k=>$v )
		$optionDftStyle .= "<option value=\"$k\">$v</option>";
	
	?>
	
	<div id="nb-mk-biblio" style="display:none" >
		<p>
		<label><b>Print Style</b></label><br />
		<select style="width:100%" id="nb-mk-biblio-print" name="print"><optgroup label="Built-in Styles"><option value="default">Default</option><?php echo $optionDftStyle ?></optgroup>
				<optgroup label="Custom Styles"><?php echo $optioncStyle ?></optgroup></select>
		</p>
		<p>
		<label for="nb-mk-biblio-headline">Headline <small>(default: References)</small></label><br />
		<input type="text" name="print_headline" style="width:100%" onblur="clean(this)" id="nb-mk-biblio-headline" />
		</p>		
		
		<p>
		<label for="nb-mk-biblio-go"><b>Copy &amp; Paste</b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-biblio',this)" name="nbcite" id="nb-mk-biblio-go"></textarea>
		</p>		
	</div>	
	<div id="nb-lst-note" style="display:none" >
		<p>
		<label for="nb-lst-note-go"><b>Copy &amp; Paste</b></label>
		<textarea rows="3" style="width:100%" id="nb-lst-note-go">[nbnote print="true"]</textarea>
		</p>	
	</div>
	
		
	<?php
	
	// GET VALID ATTRIBUTES
	$atts = netblog_sc_cite_get_attsdft();	
	$attsBasics = ''; $attsAdv = ''; $attsBasicsNum = 10; $i = 0;
	foreach( $atts as $type=>$dft ) {
		if( substr($type,0,5) == 'print' || $type == 'type' ) continue;
		if( $i==$attsBasicsNum ) { $attsBasics = $attsAdv; $attsAdv = ''; }
		$attsAdv .= '<p><label for="nb-mk-cite-'.$type.'">'.ucfirst($type).'</label><br />
			<input type="text" name="'.$type.'" value="'.$dft.'" style="width:100%" onblur="clean(this)" id="nb-mk-cite-'.$type.'" />
			</p>';
		$i++;
	}
	
	?>
	<div id="nb-mk-cite" style="display:none">
		<p>
		<label><b>Type</b></label><br />
		<select style="width:100%" name="type"><?php echo $selectFilterType ?></select>
		</p>
		
		<?php echo $attsBasics; ?>
		<div id="nb-mk-cite-attsadv" style="display:none"><?php echo $attsAdv; ?></div>
		<div style="background:#EEE; padding: 5px; text-align: center; cursor:pointer" onclick="nb_cite_reveal('nb-mk-cite-attsadv',this)">More</div>
		
		<p>
		<label for="nb-mk-cite-go"><b>Copy &amp; Paste</b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-mk-cite',this)" name="nbcite" id="nb-mk-cite-go"></textarea>
		</p>		
	</div>		
	
	<?php
	// GET ALL CAPTIONS IN DATABASE
	$captions = netblog_caption_getall();
	$captionsGroupedF = array();
	foreach( $captions as $r )
		$captionsGroupedF[ $r['type'] ] .= '<option value="'.$r['type'].'-------'.$r['name'].'">'.$r['name'].' - '.$r['num'].'</option>';
	?>
	<div id="nb-ref-caption" style="display:none" >
		<?php 
		if( sizeof($captions) == 0 ) 
			echo 'No global captions found.';
		else {
		?>
		<p>
		<label><b>Global Captions</b></label><br />
		<select onchange="mkrefcaption( this.value, '-------','nb-ref-caption-type','nb-ref-caption-ref')" id="nb-ref-caption-select">
			<?php
			foreach( $captionsGroupedF as $type=>$ct ) {
				echo '<optgroup label="'.ucfirst($type).'">'.$ct.'</optgroup>';
			}
			?>
		</select>
		</p>
		
		<input type="hidden" name="type" value="" id="nb-ref-caption-type" />
		<input type="hidden" name="ref" value="" id="nb-ref-caption-ref" />
		
		<p>
		<label for="nb-ref-caption-go"><b>Copy &amp; Paste</b></label>
		<textarea rows="3" style="width:100%" onfocus="mktag('nb-ref-caption',this)" name="nbcite" id="nb-ref-caption-go"></textarea>
		</p>	
		<?php } ?>		
	</div>
	
	
	<div class="netblog-clear"></div>

	
	<script type="text/javascript">
	<!--


	/*
	*	SELECT MENU CHOOSER - 2 LEVELS
	*/
	var main = [ {'val':'mk', 'print':'Make'}, {'val':'ref', 'print':'Reference'} ];
	var sub = [ {'val':'note', 'print':'Footnotes', 'parval':'mk'}, {'val':'cite', 'print':'Citation', 'parval':'mk'}, {'val':'caption', 'print':'Caption', 'parval':'mk'},
		{'val':'biblio', 'print':'Bibliography', 'parval':'mk'}, {'val':'caption', 'print':'Caption', 'parval':'ref'} ];

	function mksubslct( idmain, idsub )
	{
		var mainobj = document.getElementById(idmain);
		var subobj = document.getElementById(idsub);

		
		var i; var s = ' > <select onchange="mkbody(\'nb-menu-main\',\'nb-menu-sub2\')" onkeyup="mkbody(\'nb-menu-main\',\'nb-menu-sub2\')" id="nb-menu-sub2"><optgroup label="Type">';
		var count = 0;
		for( i=0; i<sub.length; i++ ) {
			if( sub[i].parval == mainobj.value ) {
				s += '<option value="'+ sub[i].val +'">'+ sub[i].print +'</option>';
				count++;
			}
		}
		s += '</optgroup></select>';
		if( count > 0 ) {
			subobj.innerHTML = s;
			mkbody('nb-menu-main','nb-menu-sub2');
		}
	}
	
	var bodyLast = null;
	function mkbody( idmain, idsub )
	{
		var mainobj = document.getElementById(idmain);
		var subobj = document.getElementById(idsub);
		var idbody = 'nb-' + mainobj.value + '-' + subobj.value;
		var body = document.getElementById(idbody);
		
		if( body != null ) {
			if( bodyLast != null ) bodyLast.style.display = 'none';
			body.style.display = 'block';
			bodyLast = body;
		}				
	}
	function mkbodyS( menuobj )
	{
		var body = document.getElementById( 'nb-' + menuobj.value );
		if( body == null ) return;
		
		if( bodyLast != null ) bodyLast.style.display = 'none';
		body.style.display = 'block';
		bodyLast = body;
	}


	function mktagByid( parseid, print2id ) {
		mktag( parseid, document.getElementById(print2id) );
	}
	function mktag( parseid, print2obj ) {
		var obj = document.getElementById(parseid);
		print2obj.innerHTML = '';
		var tagname = print2obj.name;		
		var tag = '[' + tagname;
		var content = '';
		
		var i;
		var input;
		input = obj.getElementsByTagName('input');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				content = input.item(i).value;
			else if( input.item(i).type == 'checkbox' && !input.item(i).checked )
				continue;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				tag += ' ' + input.item(i).name + '="' + input.item(i).value + '"';
		}
		input = obj.getElementsByTagName('select');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				content = input.item(i).value;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				tag += ' ' + input.item(i).name + '="' + input.item(i).value + '"';
		}
		input = obj.getElementsByTagName('textarea');
		for( i=0; i<input.length; i++ ) {
			if( input.item(i).name == 'content' )
				content = input.item(i).value;
			else if( input.item(i).value.length > 0 && input.item(i).name.length > 0 )
				tag += ' ' + input.item(i).name + '="' + input.item(i).value + '"';
		}			
		
		tag += ' ]';
		if( content.length > 0 )
			tag += content + '[/' + tagname + ']';
		
		print2obj.innerHTML = tag;
		print2obj.select();
	}
	
	
	function note_toogle( boxid, inputid )
	{
		var box = document.getElementById(boxid);
		if( box.style.display == 'block' || box.style.display == '' ) {
			box.style.display = 'none';
			document.getElementById(inputid).value = '';
		} else box.style.display = 'block';
		
	}
	function mkrefcaption( val, sep, typeid, refid )
	{
		var t = val.split(sep);
		document.getElementById(typeid).value = t[0];
		document.getElementById(refid).value = t[1];		
	}
	
	function clean(obj)
	{
		if( obj.value != 'undefined' && obj.value.length > 0 )
		{
			obj.value = obj.value.replace("\"", '' );
			obj.value = obj.value.trim();
		}
	}

	
	function nb_cite_reveal( id, fromobj )
	{
		var obj = document.getElementById(id);
		if( obj == null ) return;
		
		var d = obj.style.display;
		if( d == 'none' || d == '' ) {			
			showPlus(id,0,1000,true,true);
			fromobj.innerHTML = 'Less';
		} else {
			hidePlus(id,0,500,true,false);
			fromobj.innerHTML = 'More';
		}
	}
	
	if( document.getElementById('nb-ref-caption-select') != null )
	mkrefcaption( document.getElementById('nb-ref-caption-select').value, '-------','nb-ref-caption-type','nb-ref-caption-ref');
	
	if( document.getElementById('nb-menu') != null )
		mkbodyS( document.getElementById('nb-menu') );
	
	//-->
	</script>
	
	
	<?php
}

?>