<?php

//----------------------------------------------------------------------------------
// SETTINGS PAGE
//----------------------------------------------------------------------------------
function netblog_settings()
{
	echo '<div class="wrap">
	<div id="icon-options-general" class="icon32"><br /></div>
	<h2>Netblog Settings</h2>';

	if( isset($_POST) && sizeof($_POST) > 0 ) {
		echo '<div id="message" class="updated below-h2"><p>';
		netblog_settings_update( $_GET['sub'] );
		echo '</p></div>';
	}
		
	?>
	<br />
	<div class="netblog-main">
	<form action="<?php echo netblog_mkurl(); ?>" method="post">
		<div class="netblog-menu">
			<div class="right">
				<input type="checkbox" id="nb-help-enabled" value="true"> <label for="nb-help-enabled">Enable Help</label>
				<input type="submit" name="save" value="Save" />
			</div>		
			<a class="<?php echo netblog_settings_mkmenuclass('general'); ?>" href="<?php echo netblog_mkurl('sub=general') ?>">General</a>
			<div class="sep"></div>
			<a class="<?php echo netblog_settings_mkmenuclass('note'); ?>" href="<?php echo netblog_mkurl('sub=note') ?>">Footnotes</a>
			<a class="<?php echo netblog_settings_mkmenuclass('cite'); ?>" href="<?php echo netblog_mkurl('sub=cite') ?>">Citation</a>
			<a class="<?php echo netblog_settings_mkmenuclass('fig'); ?>" href="<?php echo netblog_mkurl('sub=fig') ?>">Caption</a>
			<!-- <div class="sep"></div>
			<a class="<?php echo netblog_settings_mkmenuclass('adv'); ?>" href="<?php echo netblog_mkurl('sub=adv') ?>">Under the Hood</a> -->
			<div class="netblog-clear"></div>		
		</div>
		<div class="body">			
			<?php			
			$sub = '';
			if( isset($_GET['sub']) ) $sub = $_GET['sub'];
			switch($sub) {
				case 'note': echo netblog_setting_note(); break;
				case 'cite': echo netblog_setting_cite(); break;
				case 'fig': echo netblog_setting_fig(); break;
				case 'adv': echo netblog_setting_adv(); break;
				default: echo netblog_settings_general();
			}			
			?>
			<div class="netblog-clear"></div>						
		</div>
	</form>
	</div>
	<?php
	
	echo '</div>';
}

function netblog_settings_mkmenuclass( $button )
{
	if( isset($_GET['sub']) && $_GET['sub'] == $button )
		return 'lnk-active';
	else return 'lnk';
}

function netblog_settings_general()
{
	ob_start();
	
	$roles = array( 'activate_plugins'=>'Administrator', 'delete_pages'=>'Editor', 'publish_posts'=>'Author', 'edit_posts'=>'Contributor', 'read'=>'Subscriber');
	$mel_tpl = array( 'new'=>'Just Added', 'popular'=>'Most Popular', 'offline'=>'Offline', 'trash'=>'Trashed' );
	
	if( isset($_GET['rmtpl']) ) {
		netblog_mel_tpl_rm($_GET['rmtpl']);
		unset($_GET['rmtpl']);
	}

	$mel_tpls_user = netblog_mel_tpls();
	?>
	<label class="col1">Metabox Further Reading</label>
		<div class="col2">&nbsp;</div>	
	 	<div class="indent">
			<div class="col1">Extern Keywords</div>	
		</div>
		<div class="col2">
			<input type="text" name="netblog_websearch_keywords" value="<?php echo get_option('netblog_websearch_keywords'); ?>" size="40" onfocus="help('hkeys',this)" onblur="help('',null)" /><br />
			<div class="helpbox" id="hkeys" style="display:none; position: relative"><div class="pad">Keywords must be space-separated, e.g. 'www http:// ftp://'.</div></div>
		</div>
			
	<div class="netblog-clear"></div>
		
	<div class="lb"></div>	
	<label class="col1">MEL - Manage Extern Links</label>
	<div class="col2"><input type="checkbox" name="netblog_mel" value="true" id="mel-enable" 
				<?php checked( get_option('netblog_mel') == 'true', true ) ?> onclick="revealPara('mel-para',this)" /> 
			<label for="mel-enable" style="font-weight:normal">Enabled</label></div>	

	<div id="mel-para" style="display:<?php echo get_option('netblog_mel') == 'true' ? 'block' : 'none' ?>">		
	 	<div class="indent">
			<div class="col1">Startup Template</div></div>
		<div class="col2"><select name="netblog_mel_start_tpl"><optgroup label="Built-in Templates"><?php 
					$tpl = get_option('netblog_mel_start_tpl');
					foreach( $mel_tpl as $k=>$nm )
						echo '<option value="'.$k.'" '.selected( $k == $tpl, true, false).'>'.$nm.'</option>';
					?></optgroup>
				<optgroup label="Custom Templates"></optgroup></select></div>
			
	 	<div class="indent">
			<div class="col1">Custom Search Templates</div></div>
		<div class="col2">
			<input type="checkbox" name="netblog_mel_tpl" value="true" id="mel-tpl-enable" 
				<?php checked( get_option('netblog_mel_tpl') == 'true', true ) ?> onclick="revealPara('mel-para-custom-tpl',this)"/> 
				<label for="mel-tpl-enable" style="font-weight:normal">Enabled</label><br />
			<div id="mel-para-custom-tpl" style="display:<?php echo get_option('netblog_mel_tpl') == 'true' ? 'block' : 'none' ?>">
				<input type="text" name="mel-tpl-name" value="" size="15" onfocus="help('hmel-tpl-name',this)" onblur="help('',null)" onkeydown="str2alphanumNW(this);input_strip(this,35)" title="Screen name" />: 
					<input type="text" name="mel-tpl-val" value="" style="width:70%" onfocus="help('hmel-tpl-query',this)" onblur="help('',null)" title="Your custom search query, e.g. wordpress tpl:new sort:id-desc,title limit:50 flag:offline" />
					<input type="submit" name="mel-add-tpl" value="Add Template" />
				<div class="helpbox" id="hmel-tpl-name" style="display:none; position: relative"><div class="pad"><b>Screen name</b><br />
					Maximum Characters: 35 | alpha-numeric only | no whitespace
					</div></div>
				<div class="helpbox" id="hmel-tpl-query" style="display:none; position: relative"><div class="pad"><b>Search query</b><br />
					<p style="margin-left: 20px">
					<u>Syntax</u><br />	
					[name]<br />				
					sort:[id,title,uri,refs,flag]<br />
					limit:[integer]<br />
					flag:[online,offline,trash]<br />
					tpl:[new,popular,offline,trash,valid custom template name]
					</p>					
					</div></div>
				<div style="padding-top: 5px; padding-bottom:15px;"><?php
					foreach( $mel_tpls_user as $nm=>$val )
						echo '<a href="'.netblog_mkurl('rmtpl='.$nm).'" class="del"></a><div class="col1">'.$nm.'</div><div class="col2-sl">'.$val.'</div>';
				?></div>				
			</div>
		</div>
			
	 	<div class="indent">
			<div class="col1">Read/Access Privilege</div></div>
		<div class="col2"><select name="netblog_mel_read"><?php 
				$r = get_option('netblog_mel_read');
				foreach( $roles as $role=>$nm )
					echo '<option value="'.$role.'" '.selected( $role == $r, true, false).'>'.$nm.'</option>';
					
			?></select></div>	
			
	 	<div class="indent">
			<div class="col1">Edit Privilege</div></div>
		<div class="col2"><select name="netblog_mel_edit"><?php 
				$r = get_option('netblog_mel_edit');
				foreach( $roles as $role=>$nm )
					echo '<option value="'.$role.'" '.selected( $role == $r, true, false).'>'.$nm.'</option>';
					
			?></select></div>			
	</div>
	
	<div class="lb"></div>		
	<label class="col1">Blogsearch</label>
	<div class="col2"><select name="blogsearch-preset"><option value="">Predefined Provider</option><option value="google">Google Blogsearch</option></select><input type="submit" name="blogsearch-tpl" value="Apply" /></div>	
	 	<div class="indent">
			<div class="col1">Provider Name</div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_provider_name" size="40" value="<?php echo get_option('netblog_blogsearch_provider_name'); ?>" />
		</div>	
	 	<div class="indent">
			<div class="col1">Provider URL</div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_provider_uri" size="40" value="<?php echo get_option('netblog_blogsearch_provider_uri'); ?>" />			
		</div>	
	 	<div class="indent">
			<div class="col1">URL</div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_uri" value="<?php echo get_option('netblog_blogsearch_uri'); ?>" style="width:100%" onfocus="help('hblog-uri',this)" onblur="help('',null)" />
			<div class="helpbox" id="hblog-uri" style="display:none; position: relative"><div class="pad"><b>Blogsearch URL</b> <small><i>must return a valid XML Feed</i></small><br />
				<div class="netblog-indent-hang-long">??count?? := will be replaced either with Global Max Results or with a lower number
					so that the total number of links displayed will not exceed the maximum
					number defined by the user in the widget section.</div>
				<div class="netblog-indent-hang-long">??query?? := will be replaced with the query.</div> 				
				</div></div>
		</div>
	 	<div class="indent">
			<div class="col1">Global Max Results</div></div>
		<div class="col2">
			<input type="text" name="netblog_blogsearch_max" size="3" value="<?php echo get_option('netblog_blogsearch_max'); ?>" />
		</div>
	
	<div class="lb"></div>	
	<label class="col1">Websearch</label>
	<div class="col2"><select name="websearch-preset"><option value="">Predefined Provider</option><option value="yahoo">Yahoo Websearch API</option></select><input type="submit" name="blogsearch-tpl" value="Apply" /></div>	
	 	<div class="indent">
			<div class="col1">Provider Name</div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_provider_name" size="40" value="<?php echo get_option('netblog_websearch_provider_name'); ?>" />
		</div>	
	 	<div class="indent">
			<div class="col1">Provider URL</div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_provider_uri" size="40" value="<?php echo get_option('netblog_websearch_provider_uri'); ?>" />
		</div>	
	 	<div class="indent">
			<div class="col1">URL</div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_uri" value="<?php echo get_option('netblog_websearch_uri'); ?>" style="width:100%" onfocus="help('hbweb-uri',this)" onblur="help('',null)" />
			<div class="helpbox" id="hbweb-uri" style="display:none; position: relative"><div class="pad"><b>Websearch URL</b> <small><i>must return a valid XML Feed</i></small><br />
				<div class="netblog-indent-hang-long">??count?? := will be replaced either with Global Max Results or with a lower number
					so that the total number of links displayed will not exceed the maximum
					number defined by the user in the widget section.</div>
				<div class="netblog-indent-hang-long">??query?? := will be replaced with the query.</div>
				</div></div>
		</div>
	 	<div class="indent">
			<div class="col1">Global Max Results</div></div>
		<div class="col2">
			<input type="text" name="netblog_websearch_max" size="3" value="<?php echo get_option('netblog_websearch_max'); ?>" />
		</div>	
		
	<script type="text/javascript">
	<!--
	/* PRINT HELP BOX */

	var optHelp = document.getElementById('nb-help-enabled');

	var lastHelpBox = null;
	
	function help( helpid, sourceObj )
	{
	if( !optHelp.checked ) return;
	
	if( lastHelpBox != null && lastHelpBox.id != helpid )
		hidePlus( lastHelpBox.id, 0, 200, true, true );
		
	var box = document.getElementById(helpid);
	if( box == null )
		return;
	
	showPlus( box.id, 400, 200, true, true );
	lastHelpBox = box;

	}	
		
	function revealPara( targetid, inObj )
	{
		var target = document.getElementById(targetid);
		if( target == null ) return;
		
		if( inObj.checked )
			showPlus(targetid,0,250,true,false);
		else hidePlus(targetid,0,250,true,false); 
	}	

	-->
	</script>		
					
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}

function netblog_setting_note()
{
	ob_start();
		
	$formats = array( 'decimal'=>1, 
					  'lower-alpha' => 'a', 'lower-greek'=>'a', 'lower-roman'=>1,
					  'upper-alpha'=> 'A', 'upper-roman' =>1 );
	
	foreach( $formats as $k=>$v ) {
		$t = array();
		$i = 1;
		$t[0] = netblog_caption_increment($i,$k,0);
		$t[1] = netblog_caption_increment($i++,$k);
		$t[2] = netblog_caption_increment($i++,$k);
		$t[3] = netblog_caption_increment($i++,$k);
		$formats[$k] = implode(', ',$t) . ', ...';
	}
	
	?>
	<label class="col1">Location</label>
		<div class="col2"><select name="netblog_note_location">
			<option value="bottom">Bottom of page</option>
			<option value="inline">Inline</option></select></div>
	<label class="col1">Format</label>
		<div class="col2">&nbsp;</div>
	 	<div class="indent">
			<div class="col1">Number format</div></div>
		<div class="col2">
			<select name="netblog_note_format">
				<?php
				$f = get_option('netblog_note_format');
				
				foreach( $formats as $k=>$v )
					echo '<option value="'.$k.'" '.selected( $k==$f, true, false).'>'.$v.'</option>';
				?>
			</select></div>
		
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}

function netblog_setting_cite()
{
	ob_start();
	
	$styledft = get_option('netblog_cite_style');
	
	$cstyles = netblog_sc_cite_styles_custom();
	$cstylesPrint = $cstyles;
	if( $cstylesPrint == '' ) $cstylesPrint = 'none';
	
	// MK SELECT FILTER TYPE
	$selectFilterType = '';
	$t = netblog_sc_cite_filter_types_default();
	foreach($t as $k=>$v)		
		$selectFilterType .= "<option value=\"$k\">$v</option>";
		

	// MK SELECT CUSTOM STYLE
	$optioncStyle = '';
	$t = strlen($cstyles) > 0 ? explode(', ',$cstyles) : array();
	foreach( $t as $v )
		if( strlen($v) > 0 )
		$optioncStyle .= "<option value=\"$v\" ".selected( $v == $styledft, true, false ).">$v</option>";

	
	// MK SELECT DEFAULT STYLES
	$optionDftStyle = '';
	$t = netblog_sc_cite_styles_default();
	foreach( $t as $v )
		$optionDftStyle .= "<option value=\"$v\" ".selected( $v == $styledft, true, false ).">$v</option>";
		
	?>
	<label class="col1">Tag Name</label>
	<div class="col2"><?php echo constant('NETBLOG_CITE_TAG'); ?></div>

	<label class="col1">Default Style</label>
	<div class="col2"><select name="netblog_cite_style"><optgroup label="Built-in Styles"><?php echo $optionDftStyle ?></optgroup>
				<optgroup label="Custom Styles"><?php echo $optioncStyle ?></optgroup></select></div>			
	
	<label class="col1">Custom Styles</label>
	<div class="col2"><?php echo $cstylesPrint; ?></div>
	
	<div class="indent">
		<div class="col1">Add Filter</div>		
	</div>
	<div class="col2">
		<select onchange="nb_copyval2val(this,'custom_style')"><option value="">Style Name</option><?php echo $optioncStyle ?></select>
		<select onchange="nb_copyval2val(this,'custom_filtertype')"><option value="">Filter Type</option><?php echo $selectFilterType ?></select><br />
		<input type="text" size="10" name="custom_style" id="custom_style"  onkeyup="str2alphanum(this);netblog_count_chars(this,'cfilter-style-chars')" onfocus="helpbox('helpbox',this);netblog_count_chars(this,'cfilter-style-chars');" onblur="helpbox('helpbox',null)"
			 />-<input type="text" size="15" name="custom_filtertype" id="custom_filtertype" onkeyup="str2alphanum(this);netblog_count_chars(this,'cfilter-type-chars')" onfocus="helpbox('helpbox2',this);netblog_count_chars(this,'cfilter-type-chars');" onblur="helpbox('helpbox2',null)"
			 />-<input type="text" style="width:60%" name="custom_filter" id="custom_filter" onkeyup="searchInput(this.id,'netblog_cite_preview(\'' + this.value + '\')');" onfocus="helpbox('helpbox3',this)" onblur="helpbox('helpbox3',null)" />
		<input type="submit" value="Apply" name="addfilter" />
		<div class="helpbox" id="helpbox" style="display:none; position: relative"></div>
		<div class="helpbox" id="helpbox2" style="display:none; position: relative"></div>
		<div class="helpbox" id="helpbox3" style="display:none; position: relative"></div>
		</div>
	<?php
	
	// LOAD CUSTOM FILTER
	$list = array();
	$cfilter = netblog_sc_cite_custom_filter();
	foreach( $cfilter as $nm=>$val) {
		$style = netblog_sc_cite_getStyleFromFilter($nm);
		$type = netblog_sc_cite_getTypeFromFilter($nm);
		$list[$style][] = array('type'=>$type,'filter'=>$val);	
	}
	
	foreach($list as $style=>$filters ) {
		echo '
			<div class="indent">
				<div class="col1">'.$style.'</div>		
			</div>
			<div class="col2">';
		foreach( $filters as $row ) {
			extract($row);
			//echo "<div><a class=\"del\"></a><div style=\"margin-left:20px\">asdf</div></div>";
			echo "<a href=\"".netblog_mkurl('rmfilter='.$style.'-'.$type)."\" class=\"del\"></a><div class=\"col1\"> $type</div><div class=\"col2-sl\">$filter</div>";
		}
		echo '</div>';
	}
	
	// MK JS HEL - VALID ATTS
	$atts = netblog_sc_cite_get_attsdft();
	$attsPtr = ''; 
	foreach( $atts as $att=>$dft ) {
		if( substr($att,0,strlen('print')) == 'print' ) continue;
		if( $dft != '' ) $dft = " [$dft]";
		$attsPtr .= '<div class="col">$'.$att.$dft.'</div>';
	}
	
	?>
	<script type="text/javascript">
	<!--
	var protectedStyles = '<?php echo implode(', ', netblog_sc_cite_styles_default() ); ?>';
	var validAtts = '';
	var maxChars = 20;
	var minChars = 3;
	
	var optHelp = document.getElementById('nb-help-enabled');
	
	/* APPLY SELECT VALUE TO HTML-ID-VALUE */
	function nb_copyval2val( objold, idnew )
	{
		document.getElementById(idnew).value = objold.value;
	} 
	
	/* PRINT HELP BOX */
	function helpbox( id, refObj )
	{
		if( !optHelp.checked ) return;
		var box = document.getElementById(id);
		if( refObj == null || typeof(refObj) == 'undefined' ) {
			//hide( box.id, 200, 200);
			hidePlus( box.id, 200, 500, true, true);
			return;
		}
			
		var refid = refObj.id;		
		var help = '';
		
		if( refid == 'custom_style' ) {			
			help += '<b>Allowed characters</b>: a-z, A-Z, 0-9<br />';
			help += 'Max characters: <span id="cfilter-style-chars">0</span> of ' + maxChars + '<br />';
			help += 'Protected Names: ' + protectedStyles + '<br />';
		} else if( refid == 'custom_filtertype' ) {
			help += '<b>Allowed characters</b>: a-z, A-Z, 0-9<br />';	
			help += 'Max characters: <span id="cfilter-type-chars">0</span> of ' + maxChars + '<br />';	
			help += 'Use of an existing filter type for your custom style will overwrite the filter.';
		} else if( refid == 'custom_filter' ) {
			help += '<b>Preview</b>: <div id="nbcite-preview" style="display:inline">No Preview</div><br /><br />';
			help += '<div class="title">Valid Keywords</div><?php echo $attsPtr ?>';
		}
		
		if( help != '' ) {
			box.innerHTML = '<div class="pad"><div class="title">Help Tool</div>' + help + '<div class="netblog-clear"></div></div>';
			//show( box.id, 0, 200);			
			showPlus( box.id, 200, 200, true, true);
		} 
	}
	
	
	function netblog_cite_preview( filter )
	{	
		jQuery(document).ready(function($) {
			var data = {
				action: 'cite_filter_preview',
				filter: filter
			};
			jQuery.post(ajaxurl, data, function(response) {
				if( response == '' || response == 'false' )
					response = 'No Preview';
					
				var prev = document.getElementById('nbcite-preview');
				if( prev != null ) {
					prev.innerHTML = response;
				} else alert(response);				
			});
		});	
	}
	
	//-->
	</script> 
	
	<?php
	
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}


function netblog_setting_fig()
{
	ob_start();
	
	$roles = array( 'activate_plugins'=>'Administrator', 'delete_pages'=>'Editor', 'publish_posts'=>'Author', 'edit_posts'=>'Contributor' );
	
	$gadd = get_option('netblog_caption_gadd');
	
	$formats = array( 'decimal'=>1, 
					  'lower-alpha' => 'a', 'lower-greek'=>'a', 'lower-roman'=>1,
					  'upper-alpha'=> 'A', 'upper-roman' =>1 );
	
	$display = array( 'inline'=>'Inline', 'left'=>'Left', 'right'=>'Right' );
	
	foreach( $formats as $k=>$v ) {
		$t = array();
		$i = 1;
		$t[0] = netblog_caption_increment($i,$k,0);
		$t[1] = netblog_caption_increment($i++,$k);
		$t[2] = netblog_caption_increment($i++,$k);
		$t[3] = netblog_caption_increment($i++,$k);
		$formats[$k] = implode(', ',$t) . ', ...';
	}

	//netblog_caption_global_set('equation','decimal','($number)','right',true);
	
	
	?>
	<label class="col1" title="Captions are automatically added when first declared in a post/page and if this privilege is met. ">Who may add global types?</label>
	<div class="col2"><select name="netblog_caption_gadd">
		<?php
		foreach( $roles as $k=>$v )
			echo '<option value="'.$k.'" '.selected($k==$gadd,true,false).'>'.$v.'</option>';
		?>
	</select></div>

		
	<?php
	
	
	$types = netblog_caption_global_types(true);
	foreach( $types as $type=>$para ) {
		?>
		<div style="float:left;display:block;width:400px; padding-right: 50px">
		<div class="col1"><input type="checkbox" name="nb-caption-<?php echo $type ?>-active" id="nb-caption-<?php echo $type ?>" value="true" <?php checked($para['active']) ?>
					onclick="revealPara('nb-caption-typepara-<?php echo $type ?>',this)"	/>
				<label for="nb-caption-<?php echo $type ?>" title="When active, these settings will override all captions in any post and in any page."><?php echo ucfirst($type); ?></label>
				<input type="hidden" name="nb-caption-types[]" value="<?php echo $type ?>" /></div>
			<div class="col2"><select name="nb-caption-<?php echo $type ?>-display">
				<?php
					foreach( $display as $k=>$v )
						echo '<option value="'.$k.'" '.selected( $k==$para['display'],true,false ).' >'.$v.'</option>';
				 ?>
				</select></div>	
			<div id="nb-caption-typepara-<?php echo $type ?>" style="display:<?php echo $para['active'] ? 'block' : 'none'; ?>">
			 	<div class="indent">
					<div class="col1">Number format</div>	
				</div>
				<div class="col2"><select name="nb-caption-<?php echo $type ?>-numformat">
					<?php 
						foreach( $formats as $k=>$v) 
							echo '<option value="'.$k.'" '.selected( $k==$para['number_format'] ).'>'.$v.'</option>';
					 ?></select></div>
			 	<div class="indent">
					<div class="col1">Print format</div>	
				</div>
				<div class="col2"><input type="text" name="nb-caption-<?php echo $type ?>-format" value="<?php echo $para['print_format'] ?>" /></div>
			 	<div class="indent">
					<label class="col1" for="nb-caption-<?php echo $type ?>-remove" style="font-weight:normal;font-style:italic">Remove permanently</label>	
				</div>
				<div class="col2"><input type="checkbox" name="nb-caption-<?php echo $type ?>-remove" id="nb-caption-<?php echo $type ?>-remove" value="true" /></div>
			<hr style="border: 1px solid #EEE" />
			</div>			
		</div>			
		<?php		
	}
	
	?>
	<div class="netblog-clear" style="height:30px"></div>
	
	<div class="col1"><label >Create a new type</label></div>
	<div class="col2"><input type="text" name="nb-caption-type-new" id="nb-caption-type-new" value="" onkeydown=";str2alphanum(this);input_strip(this,32);revealOnInput(this,'nb-caption-new')" /></div>	
	<div id="nb-caption-new" style="display:none">
	 	<div class="indent">
			<div class="col1">Number format</div>	
		</div>
		<div class="col2"><select name="nb-caption-new-numformat">
			<?php 
				foreach( $formats as $k=>$v) 
					echo '<option value="'.$k.'">'.$v.'</option>';
			 ?></select></div>
	 	<div class="indent">
			<div class="col1">Display</div>	
		</div>
		<div class="col2"><select name="nb-caption-new-display">
			<?php 
				foreach( $display as $k=>$v) 
					echo '<option value="'.$k.'">'.$v.'</option>';
			 ?></select></div>		 
	 	<div class="indent">
			<div class="col1">Print format</div>	
		</div>
		<div class="col2"><input type="text" name="nb-caption-new-format" value="($number)" /></div>
	</div>
	
	
	<label class="col1" title="">Advanced</label>
	<div class="col2"><input type="submit" name="nb-caption-rebuild" value="Rebuild Caption Numbers" /></div>
		
		
	<script type="text/javascript">
	<!--
	var minCharType = 3;
	function revealOnInput( inObj, targetid )
	{
		var target = document.getElementById(targetid);
		if( target == null ) return;
	
		if( target.style.display == '' ) 
			target.style.display = 'none';
		
		if( inObj.value.length == minCharType-1 && target.style.display != 'none' )
			hidePlus(targetid,0,250,true,false);
		else if( inObj.value.length == minCharType && target.style.display == 'none' )
			showPlus(targetid,0,250,true,false);
	}
	
	function revealPara( targetid, inObj )
	{
		var target = document.getElementById(targetid);
		if( target == null ) return;
		
		if( inObj.checked )
			showPlus(targetid,0,250,true,false);
		else hidePlus(targetid,0,250,true,false); 
	}	
	//-->
	</script>
				
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;	
	
}

function netblog_setting_adv()
{
	
	ob_start();
	
	?>
	 
	<?php
	$o = ob_get_contents();
	ob_end_clean();	
	return $o;
}


function netblog_settings_update( $sub )
{			
	// PAGE-SPECIFIC
	switch($sub) {
		//case 'note': echo netblog_setting_note(); break;
		case 'cite': echo netblog_settings_upd_cite(); break;
		case 'fig': echo netblog_settings_upd_fig(); break;
		//case 'adv': echo netblog_setting_adv(); break;
		default: echo netblog_settings_upd_general();
	}
	
	// UPDATE OPTION - GENERIC
	foreach( $_POST as $nm=>$val )
	if( is_string($val) && strlen($val) > 0 && get_option($nm) != false )
		update_option($nm,$val);
			
	echo 'Settings updated.';
}
function netblog_settings_upd_cite(){
	if( isset($_POST['addfilter'])) {
		extract($_POST);
		if( ctype_alnum($custom_style) && ctype_alnum($custom_filtertype) && strlen($custom_filter) > 0 )
			netblog_sc_cite_addFilter( $custom_style, $custom_filtertype, $custom_filter );
	}
	
	if( isset($_GET['rmfilter']) ) {
		$t = explode('-',$_GET['rmfilter']);
		netblog_sc_cite_rmFilter( $t[0], $t[1] );
	}
	unset($_GET['rmfilter']);
}

function netblog_settings_upd_general()
{
	if( isset($_POST['blogsearch-preset']) && $_POST['blogsearch-preset'] == 'google' ) {
		$t = array('NETBLOG_BLOGSEARCH_URI','NETBLOG_BLOGSEARCH_MAX','NETBLOG_BLOGSEARCH_PROVIDER_NAME','NETBLOG_BLOGSEARCH_PROVIDER_URI');
		foreach( $t as $nm )
			if(isset($_POST[strtolower($nm)]) ) $_POST[strtolower($nm)] = constant($nm); 
	}
	if( isset($_POST['websearch-preset']) && $_POST['websearch-preset'] == 'yahoo' ) {
		$t = array('NETBLOG_WEBSEARCH_URI','NETBLOG_WEBSEARCH_MAX','NETBLOG_WEBSEARCH_PROVIDER_NAME','NETBLOG_WEBSEARCH_PROVIDER_URI');
		foreach( $t as $nm )
			if(isset($_POST[strtolower($nm)]) ) $_POST[strtolower($nm)] = constant($nm);
	}	
	
	if( !isset($_POST['netblog_mel_tpl']) )
		update_option('netblog_mel_tpl','false');
	if( !isset($_POST['netblog_mel']) )
		update_option('netblog_mel','false');		
			
	if( /*isset($_POST["mel-add-tpl"]) &&*/ strlen($_POST["mel-tpl-name"]) > 0 && strlen($_POST["mel-tpl-val"]) > 0 ) {
		//$_POST['mel-tpl-name'] = netblog_str2alnum($_POST['mel-tpl-name'], false);
		netblog_mel_tpl_add( $_POST["mel-tpl-name"], $_POST["mel-tpl-val"] );
	}
}

function netblog_settings_upd_fig()
{
	$scope = 'nb-caption-';
	if( !isset($_POST[$scope.'types']) ) return;
	
	if( isset($_POST[$scope.'type-new']) && strlen($_POST[$scope.'type-new']) > 0
		 && !in_array(strtolower($_POST[$scope.'type-new']),$_POST[$scope.'types'])
		 && netblog_caption_global_get($_POST[$scope.'type-new']) == null ) {
		netblog_caption_global_set( $_POST[$scope.'type-new'], $_POST[$scope.'new-numformat'], $_POST[$scope.'new-format'], $_POST[$scope.'new-display'] );
		echo 'Added caption type <i>"'.$_POST[$scope.'type-new'].'"</i>. ';
	}
	
	foreach( $_POST[$scope.'types'] as $type ) {
		if( strlen($type) == 0 ) continue;
		
		$t = $scope.$type.'-';
		$active = false;
		if( isset($_POST[$t.'active']) && $_POST[$t.'active'] == 'true' ) $active = true;
		
		if( isset($_POST[$t.'remove']) && $_POST[$t.'remove'] == 'true' ) {
			netblog_caption_global_rm($type);
			echo 'Removed caption type <i>"'.$type.'"</i>';
		} else		
			netblog_caption_global_set( $type, $_POST[$t.'numformat'], $_POST[$t.'format'], $_POST[$t.'display'],$active );
	}
		
	if( isset($_POST['nb-caption-rebuild']) && strlen($_POST['nb-caption-rebuild']) > 0 )
		if( netblog_caption_rebuild() )
			echo 'Rebuild caption numbers. ';
		else echo 'Failed to rebuild caption numbers';	
}


?>