<?php

//---------------------------------------------------------------------------------------------------------------------
// NETBLOG_WIDGETS_REGISTER
//---------------------------------------------------------------------------------------------------------------------
add_action( 'widgets_init', 'netblog_load_widgets' );

function netblog_load_widgets() {
	register_widget( 'Netblog_Widget_Outnodes' );
	register_widget( 'Netblog_Widget_Innodes' );
}



//---------------------------------------------------------------------------------------------------------------------
// NETBLOG_WIDGET_OUTNODES
//---------------------------------------------------------------------------------------------------------------------
class Netblog_Widget_Outnodes extends WP_Widget {
	function Netblog_Widget_Outnodes() {
		// WIDGET SETTINGS
		$widget_ops = array( 'classname' => 'netblogs-outnodes', 'description' => 'A list of links to further resources on a per page/post basis; intern and extern links, Pingbacks.' );

		/* WIDGET CONTROL SETTINGS. */
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'netblog-widget-outnodes' );

		$this->WP_Widget( 'netblog-widget-outnodes', __('Further Reading', 'example'), $widget_ops );			
	}

	function form($instance) {
		$defaults = array( 'title' => 'Further Reading', 'intern' => array('size'=>15, 'pos'=>1), 'pingbacks' => array('size'=>0, 'pos'=>2), 
							'extern' => array('size'=>10, 'pos'=>3),
							'dspOnType' => array('post','page'), 'trunc' => 100  );
		$instance = wp_parse_args( (array) $instance, $defaults ); 

		$intNum = $this->get_field_id('internNum');
		$pingNum = $this->get_field_id( 'pingbacksNum' );
		$extNum = $this->get_field_id( 'externNum' );
		$dspOnPost = $this->get_field_id( 'dsp-on-post' );
		$dspOnPage = $this->get_field_id( 'dsp-on-page' );
		$dspOnOther = $this->get_field_id( 'dsp-on-other' );
		$status = $this->get_field_id( 'status' );
		$jsFuncCall['netblog_widget_oneFieldtrue'] = "netblog_widget_oneFieldtrue2('$intNum','$pingNum','$extNum','$dspOnPost','$dspOnPage','$dspOnOther','$status');";
		
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>">Title:</label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" 
				value="<?php echo $instance['title']; ?>" class="widefat" type="text" />
		</p>
		
		<b>Number of visible hyperlinks</b><br />
		<small>(0 := hidden; -1 := unlimited)</small>
		<table style="margin-left: 15px;">
		  <tr>
		    <td><label for="<?php echo $this->get_field_id( 'internNum' ); ?>">within Website</label></td>
		    <td style="padding-right: 10px"><input type="text" size="3" id="<?php echo $this->get_field_id( 'internNum' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'internNum' ); ?>"  onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'internNum' ); ?>', 15); <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>"
					value="<?php echo $instance['intern']['size']; ?>" /></td>
		    <td><input type="text" size="1" id="<?php echo $this->get_field_id( 'internPos' ); ?>"
		    		name="<?php echo $this->get_field_name( 'internPos' ); ?>" value="<?php echo $instance['intern']['pos']; ?>"
		    		 onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'internPos' ); ?>', 1);" /></td>
		  </tr>
		  <tr>
		    <td><label for="<?php echo $this->get_field_id( 'pingbacksNum' ); ?>">Pingbacks</label></td>
		    <td><input type="text" size="3" id="<?php echo $this->get_field_id( 'pingbacksNum' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'pingbacksNum' ); ?>"  onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'pingbacksNum' ); ?>', 0); <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>"
					value="<?php echo $instance['pingbacks']['size']; ?>" /></td>
		    <td><input type="text" size="1" id="<?php echo $this->get_field_id( 'pingbacksPos' ); ?>"
		    		name="<?php echo $this->get_field_name( 'pingbacksPos' ); ?>" value="<?php echo $instance['pingbacks']['pos']; ?>"
		    		 onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'pingbacksPos' ); ?>', 2);" /></td>
		  </tr>
		  <tr>
		    <td><label for="<?php echo $this->get_field_id( 'externNum' ); ?>">WWW</label></td>
		    <td><input type="text" size="3" id="<?php echo $this->get_field_id( 'externNum' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'externNum' ); ?>"  onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'externNum' ); ?>', 15); <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>"
					value="<?php echo $instance['extern']['size']; ?>" /></td>
		    <td><input type="text" size="1" id="<?php echo $this->get_field_id( 'externPos' ); ?>"
		    		name="<?php echo $this->get_field_name( 'externPos' ); ?>" value="<?php echo $instance['extern']['pos']; ?>" 
		    		 onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'externPos' ); ?>', 3);"/></td>
		  </tr>
		</table>
		<br />
		
		<label for="<?php echo $this->get_field_id( 'trunc' ); ?>"><b>Truncate hyperlinks to</b></label>
		<p style="padding-left: 20px">
			<input type="text" size="3" id="<?php echo $this->get_field_id( 'trunc' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'trunc' ); ?>" onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'trunc' ); ?>', 100);"
		    		value="<?php echo $instance['trunc']; ?>"  />
			<label for="<?php echo $this->get_field_id( 'trunc' ); ?>"> characters</label>
		</p>

		<b>Display on</b>
		<p style="padding-left: 20px">
			<input class="checkbox" type="checkbox" <?php checked( in_array('post',$instance['dspOnType']) == true, true ) ?> 
				id="<?php echo $this->get_field_id( 'dsp-on-post' ); ?>" 
				name="<?php echo $this->get_field_name( 'dsp-on-post' ); ?>" value="true"
				onclick="<?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>" />
			<label for="<?php echo $this->get_field_id( 'dsp-on-post' ); ?>">posts</label>&nbsp;
			
			<input class="checkbox" type="checkbox" <?php checked( in_array('page',$instance['dspOnType']) == true, true ); ?> 
				id="<?php echo $this->get_field_id( 'dsp-on-page' ); ?>" 
				name="<?php echo $this->get_field_name( 'dsp-on-page' ); ?>" value="true"
				onclick="<?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>" />
			<label for="<?php echo $this->get_field_id( 'dsp-on-page' ); ?>">pages</label>&nbsp;
			
			<input class="checkbox" type="checkbox" <?php checked( in_array('other',$instance['dspOnType']) == true, true ); ?> 
				id="<?php echo $this->get_field_id( 'dsp-on-other' ); ?>" 
				name="<?php echo $this->get_field_name( 'dsp-on-other' ); ?>" value="true"
				onclick="<?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>" />
			<label for="<?php echo $this->get_field_id( 'dsp-on-other' ); ?>">others</label>	
		</p>
		<div id="<?php echo $this->get_field_id( 'status' ); ?>" style="color:red;display:none">No Links will be displayed and widget will not appear.</div>

		<script type="text/javascript">
		<!--
		<?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>
		//-->
		</script>					
		
		<?php
	}

	function update($new_instance, $old_instance) {

		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['intern'] = array( 'size'=>$new_instance['internNum'], 'pos'=>$new_instance['internPos']);
		$instance['pingbacks'] = array( 'size'=>$new_instance['pingbacksNum'], 'pos'=>$new_instance['pingbacksPos']);
		$instance['extern'] = array( 'size'=>$new_instance['externNum'], 'pos'=>$new_instance['externPos']);
		$instance['trunc'] = $new_instance['trunc'];
		
		$p = array();
		if( isset($new_instance['dsp-on-post']) && $new_instance['dsp-on-post'] == 'true' )
			$p[] = 'post';
		if( isset($new_instance['dsp-on-page']) && $new_instance['dsp-on-page'] == 'true' )
			$p[] = 'page';
		if( isset($new_instance['dsp-on-other']) && $new_instance['dsp-on-other'] == 'true' )
			$p[] = 'other';
		$instance['dspOnType'] = $p;
		
        return $instance;		
	}

	// GENERATE SITE-DEPENDENT WIDGET CONTENT
	function widget($args, $instance) {		
		global $wpdb;
		global $post;		
		
		$nodeID = get_the_ID();                
        if( $nodeID == '' || !is_numeric($nodeID) || $nodeID <= '0'  ) return;
        
        // VERIFY PAGE-TYPE
			$nodePostType = netblog_getPostType($nodeID);
			if( $instance['dspOnType'] == null || !in_array($nodePostType,$instance['dspOnType']) ) return;
		
		// MK QUEUE			        
	        $queue = array();
	        $queue['intern'] = $instance['intern'];
	        $queue['pingbacks'] = $instance['pingbacks'];
	        $queue['extern'] = $instance['extern'];
	        
		// SET UP VARS
			$out;
			$num = 0;
			$truncStr = '...';
			$trunc = $instance['trunc'];
			
	        extract( $args );
	        $title = apply_filters('widget_title', $instance['title']);          
	        
	        $net = $wpdb->prefix . constant('NETBLOG_DB_NET');
	        $sql = "
				SELECT p.ID, post_title
				FROM `$net` net, $wpdb->posts p
				WHERE net.id = '$nodeID'
				AND net.adj_id = p.ID
				AND p.post_status = 'publish'
				ORDER BY p.post_date DESC;
			";			
		
			$out = $before_widget;
			if( $title ) $out.= $before_title.$title.$after_title;			
			$out.= '<ul>';
		
		// URI INDEXER - PREVENT MULTIPLE, IDENTICAL LINKS
			$uris = array();
			$linksNum = 0;
		
		$blockNum = sizeof($queue);
		for( $block=0; $block<$blockNum; $block++ ) {
			// GET NEXT BLOCK
			$pos = -1; $keyNext = '';
			foreach( $queue as $k=>$v )
				if( $pos == -1 || $v['pos'] < $pos ) { 
					$pos = $v['pos'];
					$keyNext = $k;
				}
			
			// PRINT LINKS OF BLOCK
			$size = $queue[$keyNext]['size'];
			switch($keyNext){
				
				// INTERN NET
				case 'intern':					
					$res = $wpdb->get_results($sql, ARRAY_A);
					for( $i=0; $i<sizeof($res) && ($i<$size||$size<0); $i++ ) {
						if( in_array( get_permalink($res[$i]['ID']), $uris ) ) continue;
						$out.= '<li><a href="'.get_permalink($res[$i]['ID']).'" title="'.$res[$i]['post_title'].'">'.
								netblog_cstrip($res[$i]['post_title'],$trunc,$truncStr).'</a></li>';
						$uris[] = get_permalink($res[$i]['ID']);
						$linksNum++;
					}				
					break;

				// PINGBACKS
				case 'pingbacks':					
					$pung = get_pung( $nodeID );
					$iconSrc = WP_PLUGIN_URL . '/netblog/images/external-link-ltr-icon.png';
					$num = 0;			
					foreach( $pung as $uri ) {
						if( $num >= $size && $size >= 0 ) break;
						if( strlen($uri) == 0 || in_array($uri,$uris) ) continue;
						$out .= '<li><a href="'.$uri.'" title="'.$uri.'">'.$uri.'</a>
								<img src="'.netblog_cstrip($iconSrc,$trunc,$truncStr).'" /></li>';
						$num++;
						$uris[] = $uri;
					}
					$linksNum += $num;				
					break;
				
				// EXTERN NET	
				case 'extern':		
					$extNet = netblog_getAdjacents( $nodeID, true, true );
					for( $i=0; $i<sizeof($extNet) && ($i<$size||$size<0); $i++ ) {
						if( in_array($extNet[$i]['uri'],$uris) ) continue;
						
						$iconSrc = WP_PLUGIN_URL . '/netblog/images/external-link-ltr-icon.png';
						if( substr( $extNet[$i]['uri'], -4 ) == '.pdf' )
							$iconSrc = WP_PLUGIN_URL . '/netblog/images/icons-mini-file_acrobat.gif';
						$out.= '<li><a href="'.$extNet[$i]['uri'].'" title="'.$extNet[$i]['uri_title'].'" rel="nofollow">'.
								netblog_cstrip($extNet[$i]['uri_title'],$trunc,$truncStr).'</a>
							<img src="'.$iconSrc.'" /></li>';
						$uris[] = $extNet[$i]['uri'];
						$linksNum++;
					}				
					break;
			}
			
			unset($queue[$keyNext]);
		}
			
		// PRINT WIDGET
		$out.= '</ul>';
		$out.= $after_widget;		
		if( $linksNum > 0 )
			echo $out;
	}

}




//---------------------------------------------------------------------------------------------------------------------
// NETBLOG_WIDGETS_INNODES
//---------------------------------------------------------------------------------------------------------------------
class Netblog_Widget_Innodes extends WP_Widget {
	function Netblog_Widget_Innodes() {
		// WIDGET SETTINGS
		$widget_ops = array( 'classname' => 'netblogs-innodes', 'description' => 'Show referenced resources like intern posts/pages, Pingbacks, by Blogsearch' );

		// WIDGET CONTROL SETTINGS (OPTIONAL)
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'netblog-widget-outnodes' );

		$this->WP_Widget( 'netblog-widget-innodes', __('Referenced By', 'example'), $widget_ops );			
	}

	function form($instance) {
		$defaults = array( 'title' => 'Referenced By', 'intern' => array('size'=>20, 'pos'=>1), 'pingbacks' => array('size'=>5, 'pos'=>2), 
							'blogsearch' => array('size'=>10, 'pos'=>3),
					 		'dspOnType' => array('post','page' ), 'trunc' => 100 );
		$instance = wp_parse_args( (array) $instance, $defaults ); 
		
		$intNum = $this->get_field_id('internNum');
		$pingNum = $this->get_field_id( 'pingbacksNum' );
		$blogNum = $this->get_field_id( 'blogsearchNum' );
		$dspOnPost = $this->get_field_id( 'dsp-on-post' );
		$dspOnPage = $this->get_field_id( 'dsp-on-page' );
		$dspOnOther = $this->get_field_id( 'dsp-on-other' );
		$status = $this->get_field_id( 'status' );
		$jsFuncCall['netblog_widget_oneFieldtrue'] = "netblog_widget_oneFieldtrue2('$intNum','$pingNum','$blogNum','$dspOnPost','$dspOnPage','$dspOnOther','$status');";
		
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>">Title:</label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" 
					value="<?php echo $instance['title']; ?>"  class="widefat" type="text" />
		</p>
		
		<strong>Number of visible hyperlinks</strong><br />
		<small>(0 := hidden; -1 := unlimited)</small>
		<table style="margin-left: 15px;">
		  <tr>
		    <td><label for="<?php echo $this->get_field_id( 'internNum' ); ?>">within Website</label></td>
		    <td style="padding-right: 10px"><input type="text" size="3" id="<?php echo $this->get_field_id( 'internNum' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'internNum' ); ?>"  onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'internNum' ); ?>', 15); <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>"
					value="<?php echo $instance['intern']['size']; ?>" /></td>
		    <td><input type="text" size="1" id="<?php echo $this->get_field_id( 'internPos' ); ?>"
		    		name="<?php echo $this->get_field_name( 'internPos' ); ?>" value="<?php echo $instance['intern']['pos']; ?>"
		    		 onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'internPos' ); ?>', 1);" /></td>
		  </tr>
		  <tr>
		    <td><label for="<?php echo $this->get_field_id( 'pingbacksNum' ); ?>">Pingbacks</label></td>
		    <td><input type="text" size="3" id="<?php echo $this->get_field_id( 'pingbacksNum' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'pingbacksNum' ); ?>"  onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'pingbacksNum' ); ?>', 5); <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>"
					value="<?php echo $instance['pingbacks']['size']; ?>" /></td>
		    <td><input type="text" size="1" id="<?php echo $this->get_field_id( 'pingbacksPos' ); ?>"
		    		name="<?php echo $this->get_field_name( 'pingbacksPos' ); ?>" value="<?php echo $instance['pingbacks']['pos']; ?>"
		    		 onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'pingbacksPos' ); ?>', 2);" /></td>
		  </tr>
		  <tr>
		    <td><label for="<?php echo $this->get_field_id( 'blogsearchNum' ); ?>">Blogsearch</label></td>
		    <td><input type="text" size="3" id="<?php echo $this->get_field_id( 'blogsearchNum' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'blogsearchNum' ); ?>"  onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'blogsearchNum' ); ?>', 15); <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>"
					value="<?php echo $instance['blogsearch']['size']; ?>" /></td>
		    <td><input type="text" size="1" id="<?php echo $this->get_field_id( 'blogsearchPos' ); ?>"
		    		name="<?php echo $this->get_field_name( 'blogsearchPos' ); ?>" value="<?php echo $instance['blogsearch']['pos']; ?>" 
		    		 onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'blogsearchPos' ); ?>', 3);"/></td>
		  </tr>
		</table>
		<br />		
		
		<label for="<?php echo $this->get_field_id( 'trunc' ); ?>"><strong>Truncate hyperlink to</strong></label>
		<p style="padding-left: 20px">
			<input type="text" size="3" id="<?php echo $this->get_field_id( 'trunc' ); ?>" 
		    		name="<?php echo $this->get_field_name( 'trunc' ); ?>" onblur="netblog_check_field2int('<?php echo $this->get_field_id( 'trunc' ); ?>', 100);"
		    		value="<?php echo $instance['trunc']; ?>"  />
			<label for="<?php echo $this->get_field_id( 'trunc' ); ?>"> characters</label>
		</p>
		
		<strong>Display on</strong>
		<p style="padding-left: 20px">
			<input class="checkbox" type="checkbox" <?php checked( in_array('post',$instance['dspOnType']) == true, true ) ?> 
				id="<?php echo $this->get_field_id( 'dsp-on-post' ); ?>" 
				name="<?php echo $this->get_field_name( 'dsp-on-post' ); ?>" value="true"
				onclick=" <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>" />
			<label for="<?php echo $this->get_field_id( 'dsp-on-post' ); ?>">posts</label>&nbsp;
			
			<input class="checkbox" type="checkbox" <?php checked( in_array('page',$instance['dspOnType']) == true, true ); ?> 
				id="<?php echo $this->get_field_id( 'dsp-on-page' ); ?>" 
				name="<?php echo $this->get_field_name( 'dsp-on-page' ); ?>" value="true"
				onclick=" <?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>" />
			<label for="<?php echo $this->get_field_id( 'dsp-on-page' ); ?>">pages</label>&nbsp;
			
			<input class="checkbox" type="checkbox" <?php checked( in_array('other',$instance['dspOnType']) == true, true ); ?> 
				id="<?php echo $this->get_field_id( 'dsp-on-other' ); ?>" 
				name="<?php echo $this->get_field_name( 'dsp-on-other' ); ?>" value="true"
				onclick="<?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>" />
			<label for="<?php echo $this->get_field_id( 'dsp-on-other' ); ?>">others</label>	
		</p>		
		<div id="<?php echo $this->get_field_id( 'status' ); ?>" style="color:red;display:none">No Links will be displayed and widget will not appear.</div>
			
		<script type="text/javascript">
		<!--
		<?php echo $jsFuncCall['netblog_widget_oneFieldtrue']; ?>
		//-->
		</script>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = esc_attr(strip_tags($new_instance['title']));
		$instance['intern'] = array( 'size'=>$new_instance['internNum'], 'pos'=>$new_instance['internPos']);
		$instance['pingbacks'] = array( 'size'=>$new_instance['pingbacksNum'], 'pos'=>$new_instance['pingbacksPos']);
		$instance['blogsearch'] = array( 'size'=>$new_instance['blogsearchNum'], 'pos'=>$new_instance['blogsearchPos']);
		$instance['trunc'] = $new_instance['trunc'];
		
		$p = array();
		if( isset($new_instance['dsp-on-post']) && $new_instance['dsp-on-post'] == 'true' )
			$p[] = 'post';
		if( isset($new_instance['dsp-on-page']) && $new_instance['dsp-on-page'] == 'true' )
			$p[] = 'page';
		if( isset($new_instance['dsp-on-other']) && $new_instance['dsp-on-other'] == 'true' )
			$p[] = 'other';
		$instance['dspOnType'] = $p;
				
        return $instance;		
	}

	// GENERATE SITE-DEPENDENT WIDGET CONTENT
	function widget($args, $instance) {
		global $wpdb;
		global $post;
		global $nodeID;
		
		if( $instance['size'] == '0' ) return;
		
		$curID = get_the_ID();                
        if( $curID == '' || !is_numeric($curID) || $curID <= '0'  ) return;
        
        // DISPLAY TYPE
			$nodePostType = netblog_getPostType($curID);
			if( $instance['dspOnType'] == null || !in_array($nodePostType,$instance['dspOnType']) ) return;

		// SET UP VARS
			$queue = array();
	        $queue['intern'] = $instance['intern'];
	        $queue['pingbacks'] = $instance['pingbacks'];
	        $queue['blogsearch'] = $instance['blogsearch'];
	        
			$out;
			$truncStr = '...';
			$trunc = $instance['trunc'];		
			
	        extract( $args );
	        $title = apply_filters('widget_title', $instance['title']);        
	        
	        $n = $wpdb->prefix . constant('NETBLOG_DB_NET');
	        $sql = "
				SELECT p.ID, post_title
				FROM `$n` net, $wpdb->posts p
				WHERE net.adj_id = '$curID'
				AND net.id = p.ID
				AND p.post_status = 'publish'
				ORDER BY p.post_date DESC;
			";
			
		// FORMAT WIDGET - TITLE
			$out = $before_widget;
			if( $title ) $out.= $before_title.$title.$after_title;			
			$out.= '<ul>';			

		// URI INDEXER - PREVENT MULTIPLE, IDENTICAL LINKS
			$uris = array();
			$numLinks = 0;
		

		$blockNum = sizeof($queue);
		for( $block=0; $block<$blockNum; $block++ ) {
			// GET NEXT BLOCK
			$pos = -1; $keyNext = '';
			foreach( $queue as $k=>$v )
				if( $pos == -1 || $v['pos'] < $pos ) { 
					$pos = $v['pos'];
					$keyNext = $k;
				}
				
			// PRINT LINKS OF BLOCK
			$size = $queue[$keyNext]['size'];
			switch($keyNext){
				// INTERN
				case 'intern':									
					if( $size == 0 ) break;
					
					$dbQuery = $wpdb->get_results($sql, ARRAY_A);
					for( $i=0; $i<sizeof($dbQuery) && ($i<$size || $size<0); $i++ ) {
						$perma = get_permalink($dbQuery[$i]['ID']);
						if( in_array( $perma, $uris ) ) continue;
						
						$out.= '<li><a href="'.$perma.'" title="'.$dbQuery[$i]['post_title'].'">'.
								netblog_cstrip($dbQuery[$i]['post_title'],$trunc,$truncStr).'</a></li>';
						$numLinks++;
						$uris[] = $perma;
					}
					break;

				// PINGBACKS
				case 'pingbacks':
					if( $size == 0 ) break;
					
					$com = get_approved_comments($curID);
					$iconSrc = WP_PLUGIN_URL . '/netblog/images/external-link-ltr-icon.png';
					$num = 0;
					foreach( $com as $c )
						if( $c->comment_type == 'pingback' && $num < $size && !in_array($c->comment_author_url,$uris) ) {
							$out .= '<li><a href="'.$c->comment_author_url.'" title="'.$c->comment_author.'">'.
									netblog_cstrip($c->comment_author,$trunc,$truncStr).'</a><img src="'.$iconSrc.'" /></li>';
							$num++;
							$uris[] = $c->comment_author_url;
						}
					$numLinks += $num;
					break;
					
				// BLOGSEARCH
				case 'blogsearch':
					if( $size == 0 ) break;
					
					$nodePermalink = get_permalink($curID);
					$uri = str_replace( '??query??', 'link:'.$nodePermalink, constant('NETBLOG_BLOGSEARCH_URI') );
					$uri = str_replace( '??count??', $nodesLeft>0 && $nodesLeft <= constant('NETBLOG_BLOGSEARCH_MAX') ? $nodesLeft : constant('NETBLOG_BLOGSEARCH_MAX'), $uri );
	
					$rss = fetch_feed( $uri );
					if( !is_wp_error($rss) ) {
						$maxItems = $rss->get_item_quantity( $size>0 ? $size : 0 );	// 0 := all items
						$rss_items = $rss->get_items(0, $maxitems);
	
						if( $maxItems != 0 )
						foreach( $rss_items as $item ) {
							if( in_array( $item->get_permalink(), $uris ) ) continue;
							
							$iconSrc = WP_PLUGIN_URL . '/netblog/images/external-link-ltr-icon.png';
							if( substr( $extNet[$i]['uri'], -4 ) == '.pdf' )
								$iconSrc = WP_PLUGIN_URL . '/netblog/images/icons-mini-file_acrobat.gif';						
							$out.= '<li><a href="'.$item->get_permalink().'" title="'.$item->get_title().'">'.
									netblog_cstrip($item->get_title(),$trunc,$truncStr).'</a>
									<img src="'.$iconSrc.'" /></li>';
							
							$uris[] = $item->get_permalink();
							$numLinks++;
						}
					}
											
			}
			
			unset($queue[$keyNext]);
		}
		
		// PRINT WIDGET
		$out.= '</ul>';			
		$out.= $after_widget;
		if( $numLinks > 0 )
			echo $out;

	}

}



?>